Skip to main content
POST
/
v1
/
files
/
{file_id}
/
complete-upload
Complete a multipart upload
curl --request POST \
  --url https://api.rendi.dev/v1/files/{file_id}/complete-upload \
  --header 'Content-Type: application/json' \
  --header 'X-API-KEY: <api-key>' \
  --data '
{
  "parts": [
    {
      "part_number": 2,
      "etag": "<string>"
    }
  ]
}
'
import requests

url = "https://api.rendi.dev/v1/files/{file_id}/complete-upload"

payload = { "parts": [
{
"part_number": 2,
"etag": "<string>"
}
] }
headers = {
"X-API-KEY": "<api-key>",
"Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
const options = {
method: 'POST',
headers: {'X-API-KEY': '<api-key>', 'Content-Type': 'application/json'},
body: JSON.stringify({parts: [{part_number: 2, etag: '<string>'}]})
};

fetch('https://api.rendi.dev/v1/files/{file_id}/complete-upload', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));


{
  "bitrate_audio_kb": 128,
  "bitrate_video_kb": 4000,
  "codec": "h264",
  "duration": 30,
  "environment_name": "main",
  "file_format": "mp4",
  "file_id": "987fcdeb-a89b-43d3-b456-789012345678",
  "file_type": "video",
  "frame_rate": 30,
  "height": 1080,
  "is_deleted": false,
  "is_varying_frame_rate": false,
  "mime_type": "video/mp4",
  "original_file_url": "https://storage.rendi.dev/sample/big_buck_bunny_720p_5sec_intro.mp4",
  "pixel_format": "yuv420p",
  "rendi_store_type": "STORED_FILE",
  "size_mbytes": 2.27,
  "status": "STORED",
  "storage_url": "https://storage.rendi.dev/files/224ea098-5c10-419b-8a77-707d89443c56/987fcdeb-a89b-43d3-b456-789012345678/output.mp4",
  "timebase": "1/25",
  "video_profile_level": "main",
  "width": 1920
}
{
"detail": "Invalid authorization key"
}
{
"detail": [
{
"loc": [
"<string>"
],
"msg": "<string>",
"type": "<string>"
}
]
}
Step 3 of 3 in the direct-upload flow. See the direct upload guide for the full flow.After this call succeeds, Rendi analyzes the file with FFprobe to extract media metadata. The response returns status: UPLOADED immediately; poll GET /v1/files/{file_id}status becomes STORED when analysis completes and metadata (duration, dimensions, codec, mime type, bitrate, etc.) is populated.

Authorizations

X-API-KEY
string
header
required

Path Parameters

file_id
string
required

Body

application/json
parts
UploadPart · object[]
required

One entry per uploaded part, in order. Every part_number from 1 to N must be present.

Minimum array length: 1

Response

Upload completed; file is being ffrpobed

Represents a file stored by rendi. Could either be an uploaded file or a file generated by running a command.

This model contains metadata about files stored in rendi storage, including file details, media information, and storage location.

file_id
string
required

Unique identifier for the stored file

Example:

"987fcdeb-a89b-43d3-b456-789012345678"

environment_name
string | null

The environment this file was stored in (e.g., 'main', 'test', 'dev').

Example:

"main"

storage_url
string | null

URL where the file is stored

Example:

"https://storage.rendi.dev/123e4567-e89b-12d3-a456-426614174000/output.avi"

status
enum<string> | null

Status of the file

Available options:
QUEUED,
DOWNLOADING,
DOWNLOADED,
UPLOADED,
FAILED,
STORED
Example:

"STORED"

rendi_store_type
enum<string> | null

Type of storage of the file in rendi

Available options:
INPUT,
OUTPUT,
STORED_FILE
Example:

"STORED_FILE"

error_status
string | null

Status of any error that occurred during file processing

Example:

"UNREACHABLE_INPUT_FILE"

external_error_message
string | null

Error details if the file failed to be processed

Example:

"Input file url https://rendi.dev/example is not reachable."

is_deleted
boolean | null

Whether the file has been deleted

Example:

false

size_mbytes
number | null

Size of the output file or folder in megabytes

Example:

15.2

file_count
integer | null

Number of files in the output folder/playlist

Example:

5

size_compressed_mbytes
number | null

Size of the output compressed folder in megabytes

Example:

15.2

is_private
boolean | null

Whether the file is stored privately. Private files are accessible via their storage_url only if you request a presigned URL by passing presigned_ttl_seconds on GET /v1/files/{file_id} (for a single file) or GET /v1/commands/{command_id} (for a command's output files) to receive a time-limited downloadable URL. Not available on free plans.

Example:

false

original_file_url
string | null

URL of the original file (or just name in case of uploaded file)

Example:

"https://somehwereonline.stored.com/file_to_store.mp4"

duration
number | null

Duration of the media file in seconds

Example:

30.5

file_type
string | null

Type of the media file (video, audio, image, subtitles, etc.)

Example:

"video"

file_format
string | null

Format/container of the media file

Example:

"avi"

width
integer | null

Width of the video in pixels

Example:

1920

height
integer | null

Height of the video in pixels

Example:

1080

codec
string | null

Codec used for the media file

Example:

"msmpeg4v2"

timebase
string | null

How time is represented in the media file

Example:

"1/25"

pixel_format
string | null

How the pixel data is stored in the media file

Example:

"yuv420p"

mime_type
string | null

MIME type of the media file

Example:

"video/mp4"

frame_rate
number | null

Frame rate of the video in frames per second

Example:

30

bitrate_video_kb
number | null

Video bitrate in kilobits per second

Example:

4000

bitrate_audio_kb
number | null

Audio bitrate in kilobits per second

Example:

128

video_profile_level
string | null

Video profile level

Example:

"main"

is_varying_frame_rate
boolean | null

Whether the video has a variable frame rate

Example:

false